/*
   This class can be used as a wrapper for linked lists.

   Author: Luca Anchora, <luca.anchora@imtlucca.it>
   Date: 24th March 2010
*/
#ifndef LIST_H
#define LIST_H

namespace ns3{

struct list_element{
	void* object;
	struct list_element* next;
	struct list_element* prev;
};

class List{
public:
	List();
	~List();
public:
	unsigned int len(){return len_;}
	void* head(){return (head_)?head_->object:0; }
	void* tail(){return (tail_)?tail_->object:0; }
	void enqueue(void* obj);
	void empty();
	void put_position(void* obj, unsigned int pos); //add an element in a specific position
	void start_scanning(){ curr_item = 0; }
	void* next_item(); //allows to scan the list in sequential order
	void remove_item(void*); //remove from the list a specific element
	void* dequeue(); //remove the queue of the list
private:
	unsigned int len_;
	struct list_element* curr_item; //used by the iterator for sequential scanning
	struct list_element* head_;
	struct list_element* tail_;
};

}
#endif //LIST_H

