/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2011 IMT Lucca
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Luca Anchora  <luca.anchora@imtlucca.it>
 */

#ifndef CENTRAL_AUTHORITY_H
#define CENTRAL_AUTHORITY_H
#include <vector>
#include <ns3/type-id.h>
#include <ns3/object.h>
#include <ns3/simulator.h>
#include "enb-phy.h"
#include "miscellaneous.h"
#include "List.h"

namespace ns3{

class EnbLtePhy;

class CentralAuthority: public Object

{
public:
	CentralAuthority();
	virtual ~CentralAuthority();

	static TypeId GetTypeId (void);

	void RegistereNB(Ptr<LtePhy>);


	/**
	 * 'Smart algorithm'. In case of allocation conflicts the eNBs bargain on the 
	 * common resources.
	*/
	void GetAllocationMapSmartAlgoAsymmLoad(void* prop_alloc_map);

private:
	std::vector<Ptr<EnbLtePhy> > m_eNB;
	std::vector<void*> m_maps;
	std::vector<void*> m_maps_noshar;
	std::vector<void*> m_channState;;
	int m_count_received; //count the number of allocation maps received by the registered eNBs
	int m_count_eNB; //count the number of eNBs registered to the authority

};

}// namespace ns3

#endif /* CENTRAL_AUTHORITY_H */
