/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2009 CTTC
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Nicola Baldo <nbaldo@cttc.es>
 */


#include<ns3/wifi-phy-tag.h>

namespace ns3 {

TypeId 
WifiPhyTag::GetTypeId (void)
{
  static TypeId tid = TypeId ("ns3::WifiPhyTag")
    .SetParent<Tag> ()
    ;
  return tid;
}

TypeId 
WifiPhyTag::GetInstanceTypeId (void) const
{
  return GetTypeId ();
}
uint32_t 

WifiPhyTag::GetSerializedSize (void) const
{
  return 8;
}

void 
WifiPhyTag::Serialize (TagBuffer i) const
{
  i.WriteU32 (m_wifiModeUid);
  i.WriteU32 (m_wifiPreamble);
}

void 
WifiPhyTag::Deserialize (TagBuffer i)
{
  m_wifiModeUid = i.ReadU32 ();
  m_wifiPreamble = i.ReadU32 ();
}
void 
WifiPhyTag::Print (std::ostream &os) const
{
  os << WifiMode(m_wifiModeUid) << " " << (m_wifiPreamble ? "SP" : "LP");
}

WifiPhyTag::WifiPhyTag()
{
}

WifiPhyTag::WifiPhyTag(WifiMode mode, WifiPreamble preamble)
  : m_wifiModeUid(mode.GetUid()),
    m_wifiPreamble(preamble)
{
}

// void 
// WifiPhyTag::SetWifiMode (WifiMode mode)
// {
//   m_wifiModeUid = mode.GetUid();
// }
  
WifiMode 
WifiPhyTag::GetWifiMode (void) const
{
  return WifiMode(m_wifiModeUid);
}

// void 
// WifiPhyTag::SetWifiPreamble (WifiPreamble preamble)
// {
//   m_wifiPreamble = preamble;
// }

WifiPreamble 
WifiPhyTag::GetWifiPreamble (void) const
{
  return ((enum WifiPreamble) m_wifiPreamble);
}

} // namespace ns3
