/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2009 CTTC
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Nicola Baldo <nbaldo@cttc.es>
 */

#include<ns3/ptr.h>
#include<ns3/object.h>
#include<ns3/wifi-phy.h>
#include<ns3/spectrum-phy.h>
#include<ns3/wifi-spectrum-phy-interface.h>
#include<ns3/log.h>

#include"spectrum-yans-wifi-phy.h"

NS_LOG_COMPONENT_DEFINE ("WifiSpectrumPhyInterface");

namespace ns3 {

NS_OBJECT_ENSURE_REGISTERED (WifiSpectrumPhyInterface);

TypeId 
WifiSpectrumPhyInterface::GetTypeId (void)
{
  static TypeId tid = TypeId ("ns3::WifiSpectrumPhyInterface")
    .SetParent<SpectrumPhy> ()
  ;
  return tid;
}

void WifiSpectrumPhyInterface::SetSpectrumYansWifiPhy(SpectrumYansWifiPhy* spectrumYansWifiPhy)
{
  m_spectrumYansWifiPhy = spectrumYansWifiPhy;
}

Ptr<NetDevice>
WifiSpectrumPhyInterface::GetDevice()
{
  return (m_spectrumYansWifiPhy->GetDevice ())->GetObject<NetDevice> ();
}

Ptr<MobilityModel>
WifiSpectrumPhyInterface::GetMobility()
{
  return (m_spectrumYansWifiPhy->GetMobility ())->GetObject<MobilityModel> ();
}

void 
WifiSpectrumPhyInterface::StartRx(Ptr<Packet> p, Ptr <const SpectrumValue> rxPowerSpectrum, Time duration, Ptr<SpectrumPhy> sender)
{
  m_spectrumYansWifiPhy->StartRx(p, rxPowerSpectrum, duration, sender);
}



} //namespace ns3
