/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2009 CTTC
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Nicola Baldo <nbaldo@cttc.es>
 */

#ifndef WIFI_SPECTRUM_PHY_INTERFACE_H
#define WIFI_SPECTRUM_PHY_INTERFACE_H

namespace ns3 {

#include<ns3/ptr.h>
#include<ns3/object.h>
#include<ns3/wifi-phy.h>
#include<ns3/spectrum-phy.h>


class SpectrumYansWifiPhy;

class WifiSpectrumPhyInterface : public SpectrumPhy
{
public: 
  static TypeId GetTypeId (void);
  void SetSpectrumYansWifiPhy(SpectrumYansWifiPhy* phy);
  virtual Ptr<NetDevice> GetDevice ();     
  virtual Ptr<MobilityModel> GetMobility ();
  virtual void StartRx(Ptr<Packet> p, Ptr <const SpectrumValue> rxPowerSpectrum, Time duration, Ptr<SpectrumPhy> sender); 
  
private:
  SpectrumYansWifiPhy* m_spectrumYansWifiPhy;
};


} //namespace ns3



#endif  /* WIFI_SPECTRUM_PHY_INTERFACE_H */
